javax.persistence

## Annotation Type TableGenerator

    @Repeatable(value=TableGenerators.class)
     @Target(value={TYPE,METHOD,FIELD})
     @Retention(value=RUNTIME)
    public @interface TableGenerator

Defines a primary key generator that may be referenced by name when a generator element is specified for the `GeneratedValue` annotation. A table generator may be specified on the entity class or on the primary key field or property. The scope of the generator name is global to the persistence unit (across all generator types).

        Example 1:

        @Entity public class Employee {
            ...
            @TableGenerator(
                name="empGen",
                table="ID_GEN",
                pkColumnName="GEN_KEY",
                valueColumnName="GEN_VALUE",
                pkColumnValue="EMP_ID",
                allocationSize=1)
            @Id
            @GeneratedValue(strategy=TABLE, generator="empGen")
            int id;
            ...
        }

        Example 2:

        @Entity public class Address {
            ...
            @TableGenerator(
                name="addressGen",
                table="ID_GEN",
                pkColumnName="GEN_KEY",
                valueColumnName="GEN_VALUE",
                pkColumnValue="ADDR_ID")
            @Id
            @GeneratedValue(strategy=TABLE, generator="addressGen")
            int id;
            ...
        }

Since:
  Java Persistence 1.0
See Also:
  `GeneratedValue`

### Required Element Summary

Required Elements
`String` `name` (Required) A unique generator name that can be referenced by one or more classes to be the generator for id values.

### Optional Element Summary

Optional Elements
`int` `allocationSize` (Optional) The amount to increment by when allocating id numbers from the generator.
`String` `catalog` (Optional) The catalog of the table.
`Index[]` `indexes` (Optional) Indexes for the table.
`int` `initialValue` (Optional) The initial value to be used to initialize the column that stores the last value generated.
`String` `pkColumnName` (Optional) Name of the primary key column in the table.
`String` `pkColumnValue` (Optional) The primary key value in the generator table that distinguishes this set of generated values from others that may be stored in the table.
`String` `schema` (Optional) The schema of the table.
`String` `table` (Optional) Name of table that stores the generated id values.
`UniqueConstraint[]` `uniqueConstraints` (Optional) Unique constraints that are to be placed on the table.
`String` `valueColumnName` (Optional) Name of the column that stores the last value generated.

### Element Detail

#### name

    public abstract String name

(Required) A unique generator name that can be referenced by one or more classes to be the generator for id values.

#### table

    public abstract String table

(Optional) Name of table that stores the generated id values.

Defaults to a name chosen by persistence provider.

Default:
  ""

#### catalog

    public abstract String catalog

(Optional) The catalog of the table.

Defaults to the default catalog.

Default:
  ""

#### schema

    public abstract String schema

(Optional) The schema of the table.

Defaults to the default schema for user.

Default:
  ""

#### pkColumnName

    public abstract String pkColumnName

(Optional) Name of the primary key column in the table.

Defaults to a provider-chosen name.

Default:
  ""

#### valueColumnName

    public abstract String valueColumnName

(Optional) Name of the column that stores the last value generated.

Defaults to a provider-chosen name.

Default:
  ""

#### pkColumnValue

    public abstract String pkColumnValue

(Optional) The primary key value in the generator table that distinguishes this set of generated values from others that may be stored in the table.

Defaults to a provider-chosen value to store in the primary key column of the generator table

Default:
  ""

#### initialValue

    public abstract int initialValue

(Optional) The initial value to be used to initialize the column that stores the last value generated.

Default:
  0

#### allocationSize

    public abstract int allocationSize

(Optional) The amount to increment by when allocating id numbers from the generator.

Default:
  50

#### uniqueConstraints

    public abstract UniqueConstraint[] uniqueConstraints

(Optional) Unique constraints that are to be placed on the table. These are only used if table generation is in effect. These constraints apply in addition to primary key constraints.

Defaults to no additional constraints.

Default:
  {}

#### indexes

    public abstract Index[] indexes

(Optional) Indexes for the table. These are only used if table generation is in effect. Note that it is not necessary to specify an index for a primary key, as the primary key index will be created automatically.

Since:
  Java Persistence 2.1

Default:
  {}